#define _GNU_SOURCE
#include <pthread.h>
#include <err.h>
#include <assert.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <sys/prctl.h>

#define MAP_SIZE (4096UL*2)
#define MAP_ADDR (4096UL * 512 * 512 - 4096UL)

#define SYSCHK(x) ({          \
  typeof(x) __res = (x);      \
  if (__res == (typeof(x))-1) \
    err(1, "SYSCHK(" #x ")"); \
  __res;                      \
})

static void *thread_fn(void *dummy) {
  int pagemap_fd = SYSCHK(open("/proc/self/pagemap", O_RDONLY));

  SYSCHK(prctl(PR_SET_NAME, "SLOWME"));

  usleep(350);
  char buf[MAP_SIZE / 4096 * 8];
  off_t off = MAP_ADDR / 4096 * 8;
  assert(SYSCHK(pread(pagemap_fd, buf, sizeof(buf), off)) == sizeof(buf));

  return NULL;
}

int main(void) {
  sync();

  SYSCHK(mmap((void*)MAP_ADDR, MAP_SIZE, PROT_READ|PROT_WRITE, MAP_ANONYMOUS|MAP_PRIVATE|MAP_FIXED_NOREPLACE|MAP_NORESERVE, -1, 0));
  for (int i=0; i<MAP_SIZE; i+=0x1000)
    *(volatile char *)(MAP_ADDR + i);

  pthread_t thread;
  if (pthread_create(&thread, NULL, thread_fn, NULL))
    errx(1, "pthread_create");

  SYSCHK(prctl(PR_SET_NAME, "SLOW1"));
  SYSCHK(munmap((void*)MAP_ADDR, MAP_SIZE));
  SYSCHK(prctl(PR_SET_NAME, "DUMMY"));
}
